
ivec2 atlasSize = textureSize(tex, 0);

vec2 mincoord = floor(Texcoord * atlasSize / texRes) * texRes / atlasSize;
vec2 maxcoord = ceil(Texcoord * atlasSize / texRes) * texRes / atlasSize;

vec2 clampOffset(vec2 coord)
{
    return mod(coord - mincoord, maxcoord - mincoord) + mincoord;
}

#ifdef MC_NORMAL_MAP
vec3 ParallaxOffsetCoord(vec2 texcoord, vec3 texelPos)
{
    vec3 testPoint = vec3(texcoord, 0.0);
    vec3 direction = (texelPos);
    direction = direction / direction.z / vec3(-atlasSize, 1.0) * vec3(texRes, 1.0);
    //direction *= 0.1;
    for(int i = 0;i < 16;i++)
    {
        testPoint += direction * (TERRIAN_PARALLAX_MAXDEPTH - texture(normals, clampOffset(testPoint.xy)).a * TERRIAN_PARALLAX_MAXDEPTH) / 16;
    }
    return testPoint;
}
#endif